#include <iostream>

using namespace std;
bool moguce(int brojevia,int brojevib, int brojevio,int o,int a,int b)
{
    if (brojevio < o)
        return false;
    else
        {
            brojevio = brojevio-o;
            if (brojevia<a)
            {
                if (brojevia+brojevio > a)
                {
                    brojevio = brojevio+brojevia-a;
                    brojevia = 0;
                    if (brojevib<b)
                    {
                        if (brojevib+brojevio > b)
                        {
                            return true;
                        }
                        else

                            return false;

                        }
                    else
                    {
                        return true;
                    }

                }
                else
                    return false;
            }
            else
            {
                brojevia = brojevia-a;
                if (brojevib<b)
                {
                    if (brojevib+brojevio > b)
                    {
                        return true;
                    }
                    else

                        return false;

                }
                else
                {
                    return true;
                }
            }


        }
}
int main()
{
    int n, brojo, broja, brojb, brojab, potrebnezao = 0,potrebnezaa = 0,potrebnezab = 0,potrebnezaab = 0, proslibrojo;
    cin >> n;
    cin >> brojo>>broja>>brojb>>brojab;
    string krvnegrupe[n];
    int brojkrvnegrupe[n];
    for (int i = 0; i<n; i++)
    {
        cin >> krvnegrupe[i]>>brojkrvnegrupe[i];
        if (krvnegrupe[i]== "O")
            {
                potrebnezao += brojkrvnegrupe[i];
            }
        else if (krvnegrupe[i]== "A")
            {
                potrebnezaa += brojkrvnegrupe[i];
            }
        else if (krvnegrupe[i]== "B")
            {
                potrebnezab += brojkrvnegrupe[i];
            }
        else if(krvnegrupe[i]=="AB")
            {
                potrebnezaab += brojkrvnegrupe[i];
            }
    }
    if (moguce(broja,brojb,brojo,potrebnezao,potrebnezaa,potrebnezab))
    {
        cout << "moguce"<<endl;
        for (int k = 0; k<n; k++)
        {
            if (krvnegrupe[k]=="A")
            {
                if (broja >= brojkrvnegrupe[k])
                {
                    broja = broja-brojkrvnegrupe[k];
                    cout << "0 "<< brojkrvnegrupe[k]<<" 0"<<" 0"<<endl;
                }

                else
                {
                    proslibrojo = brojo;
                    brojo = broja+brojo-brojkrvnegrupe[k];
                    cout << proslibrojo-brojo<<" " << broja << " 0" << " 0"<<endl;
                    broja = 0;
                }

            }
            else if (krvnegrupe[k]== "B")
            {
                if (brojb >= brojkrvnegrupe[k])
                {
                    brojb = brojb-brojkrvnegrupe[k];
                    cout << "0"<< " 0 "<<brojkrvnegrupe[k]<<" 0"<<endl;
                }

                else
                {
                    proslibrojo = brojo;
                    brojo = brojb+brojo-brojkrvnegrupe[k];
                    cout << proslibrojo-brojo << " 0 " << brojb << " 0"<<endl;
                    brojb = 0;
                }
            }
            else if(krvnegrupe[k]=="O")
            {
                proslibrojo = brojo;
                brojo = brojo - brojkrvnegrupe[k];
                cout << proslibrojo-brojo<<" 0"<<" 0"<<" 0"<<endl;
            }

        }
    }
    else
        cout << "nemoguce"<<endl;




}